<?php
/**
 * @package Woocommerce AI Suggested Products
 * @version 1.0
 */
/*
Plugin Name: Woocommerce AI Suggested Products
Plugin URI: https://qwebmaster.com/woocommerce-ai-suggested-products/
Description: Boost your sales by harnessing the power of artificial inelegance. Woocommerce AI Suggested Products suggests products to customers based on what they currently have in the cart and past orders made by your customers.
Version: 1.0
Author URI: http://qwebmaster.com
*/

require_once('php-ml/vendor/autoload.php');
use Phpml\Association\Apriori;

if ( is_admin() ) {
    require_once('admin/settings.php');
}

//namespace WOOCOMMERCE_AI;
// If this file is called directly, abort.
if (!defined('WPINC')) {
    die;
}

/**
 * The code that runs during plugin activation.
 */
function activation() {
    //require_once plugin_dir_path(__FILE__) . 'includes/class-activator.php';
    //Activator::activate();
}



/*
* DEBUG START
*/

/*
* Human Readable array
* @ debug
*/
function qwebmaster_print_array($aArray) {
echo '<pre>';
print_r($aArray);
echo '</pre>';
}



/*
* Process Logger, will log all import results to a file
* @ returns Data
*/
function qwebmaster_logger($data= '',$file = '',$function = '') {
   // sanmar_import_log.txt
   // sanmar_import_error_log.txt

   // Clean Log
   if ($function == 'clean') {
     $file = get_home_path() . '/'.$file.'.html';
     //$open = fopen( $file, "a" );
     $write = file_put_contents( $file, '' );


   }

   $html = '';
   if (is_array($data)) {

     foreach ($data as $key => $value) {
         if (is_array($value)) {
            foreach ($value as $sub_key => $sub_value) {
              $html .= '<span><b>'.$sub_key.'</b>: '.$sub_value.'</span> ';
            }
         }
       $html .= '<span><b>'.$key.'</b>: '.$value.'</span> ';
     }

   } else {
     $html = $data;
   }
   //ob_start();
   //var_dump($data);
   //$result = ob_get_clean();
   $file = get_home_path() . '/'.$file.'.html';
   $open = fopen( $file, "a" );
   $write = fputs( $open, $html );
   fclose( $open );
}

/*
qwebmaster_logger( '<p>Importing Variable Product UNIQUE_KEY: '.$product['UNIQUE_KEY'].'</p>', ‘filemane_log' );
qwebmaster_logger( array(
  '123' => 'eeeee',
  '1www23' => 'eeewwwee'
), ‘filename_log' );

qwebmaster_logger( array(
  '123' => 'eeeee',
  '1www23' => 'eeewwwee'
), ‘filename_error_log' );
*/

/*
 * Get ALL Post actions on a page
 * @ debug
 */
if(isset($_GET['actions'])){
$debug_tags = array();
add_filter( 'all', function ( $tag ) {
    global $debug_tags;
    if ( in_array( $tag, $debug_tags ) ) {
        return;
    }
    echo "<pre>" . $tag . "</pre>";
    $debug_tags[] = $tag;
});
}

/*
* DEBUG END
*/

/**
 * Woocommerce AI Shortcode
 *
 * Get an array of Woocommerce orders, returns only orders that contain 2 or more items
 *
 * @since v1 Initial Public Relese.
 */
add_shortcode('qwebmaster_shortcode', 'qwebmaster_shortcode');
function qwebmaster_shortcode( $atts = array(), $content = null ) {
}

/**
 * Get Woocomemrce orders
 *
 * Get an array of Woocommerce orders, returns only orders that contain 2 or more items
 *
 * @since v1 Initial Public Relese.
 */
function qwebmaster_ai_get_orders($posts_per_page = 500) {
// Query runs when there is no valid transient set
if ( false === ( $value = get_transient( 'qwebmaster_ai_get_orders' ) ) ) {
  global $woocommerce;
    $filters = array(
    'post_status' => 'any',
    'post_type' => 'shop_order',
    'posts_per_page' => $posts_per_page,
    // Important for memory usage
    'cache_results'  => false,
    'paged' => 1,
    'orderby' => 'modified',
    'order' => 'DSC'
    );

    $loop = new WP_Query($filters);
    $samples = [];
    while ($loop->have_posts()) {
      $loop->the_post();
      $order = new WC_Order($loop->post->ID);
    $samples_order = [];
     foreach ($order->get_items() as $item_id => $item_data) {
        if ($item_data['variation_id']) {
          //echo 'Product Type : Variable Product' . '<br>';
        } else {
          //echo 'Product Type : Simple Product' . '<br>';
        }
        if ($item_data['product_id'] != 0) {
        array_push($samples_order, $item_data['product_id']);
        }
     }
// If sample orders are less than 2 AND sample orders are not empty AND OR ITEMS ARE LESS THAN 4
if (count($samples_order) != 1 && !empty($samples_order) && count($samples_order) <= 4) {
$samples[] = $samples_order;
}
// Future use
/*
wp_cache_delete( $loop->post->ID, 'posts' );
wp_cache_delete( $loop->post->ID, 'post_meta' );
*/
   }
   // Reset the query!
   wp_reset_query();
   set_transient( 'qwebmaster_ai_get_orders', $samples, 60*60*12 );
 } else {
   $samples = get_transient( 'qwebmaster_ai_get_orders' );
   //qwebmaster_logger( $samples, 'debug_log' );
 }// End Transient
   return $samples;
}


/**
 * Process Data using the Apriori Algorithm
 *
 * Process Data
 *
 * @since v1 Initial Public Relese.
 */
function qwebmaster_ai_apriori($data,$predict) {
 // Future use
 // Support based on post count
 $sample_array_size= count($data);
 switch (true) {
     case $sample_array_size <= 50:
         $support_val = 0.01;
         break;

     case $sample_array_size >= 200:
         $support_val = 0.01;
         break;

     case $sample_array_size >= 1000:
         $support_val = 0.01;
         break;

     default:
         $support_val = 0.01;
         break;
 }
  $labels  = [];
  $associator = new Apriori($support = $support_val, $confidence = 0.1);
  $associator->train($data, $labels);
  $predict = $associator->predict([$predict]);
  return $predict;
  //return $associator->apriori();
}

// FUTURE USE
/*
//add_filter ( 'wc_add_to_cart_message_html', 'wc_add_to_cart_message_html_filter', 10, 2 );
function wc_add_to_cart_message_html_filter( $message, $products ) {
$cart_product_ids =[];
foreach( $products as $product_id => $quantity ){
  array_push($cart_product_ids, $product_id);
}
$orders = qwebmaster_ai_get_orders();
//qwebmaster_logger( qwebmaster_print_array(qwebmaster_ai_apriori($orders,$cart_product_ids)), 'debug_log' );
}
*/

/**
 * Multi to single dimentional array
 *
 * Convert Multidimentioanl array to single dimentional
 *
 * @since v1 Initial Public Relese.
 */
function qwebmaster_ai_convert_array( $array ) {
// Convert to a simple array
$convert_array = [];
foreach ($array as $key => $prediction) {
  foreach ($prediction as $sub_key => $product_array) {

    foreach ($product_array as $product_id) {
        $convert_array[] = $product_id;
    }
  }
}
return $convert_array;
}

/**
 * Filter Array
 *
 * COpare products in cart with the predictions and remove any prediction id's that are alredy in cart.
 *
 * @since v1 Initial Public Relese.
 */
function qwebmaster_ai_filter_array( $array , $cart_product_ids ) {
  foreach ($array as $key => $product_id) {
    foreach ($cart_product_ids as $cart_product_id) {
      if ($cart_product_id == $product_id) {
        unset($array[$key]);
      }
    }
  }
  return array_filter($array);
}

/**
 * Get Items in Cart
 *
 * Get all cart items
 *
 * @since v1 Initial Public Relese.
 */
function qwebmaster_ai_cart_items( $products,  $prediction_limit = 3  ) {

}


/**
 * Html Output
 *
 * Output predicted products HTML
 *
 * @since v1 Initial Public Relese.
 */
function qwebmaster_ai_product_tempalte( $products, $template ='default'  ) {
  $html = include('templates/'.$template.'.php');
  return $html;
}

/**
 *
 * Woocommerce Display total order cout
 *
 * @since v1 Initial Public Relese.
 */
function qwebmaster_ai_woocommerce_total_order_count( $atts = null , $content = null ) {
	$args = shortcode_atts( array(
		'status' => 'completed',
	), $atts );
	$statuses    = array_map( 'trim', explode( ',', $args['status'] ) );
	$order_count = 0;
	foreach ( $statuses as $status ) {
		// if we didn't get a wc- prefix, add one
		if ( 0 !== strpos( $status, 'wc-' ) ) {
			$status = 'wc-' . $status;
		}
		$order_count += wp_count_posts( 'shop_order' )->$status;
	}
	ob_start();
	echo  $order_count;
	return ob_get_clean();
}




/**
 *
 *
 * Woocommerce AI Suggested Products Position fiters
 *
 * @since v1.0 Initial Public Relese.
 */
add_action('wp', 'qwebmaster_ai_woocommerce_filters');
function qwebmaster_ai_woocommerce_filters() {
  // Plugin options Array
  $options = get_option( 'wasp_option' );
    // Cart Page
    if ( isset($options['wasp_enable_cart']) && $options['wasp_enable_cart'] == 1) {

      // Position
      if ( $options['wasp_location_cart'] == 'top') {
         add_filter ( 'woocommerce_before_cart_table', 'qwebmaster_ai_woocommerce_display', 10, 2 );
      }
      if ( $options['wasp_location_cart'] == 'bottom') {
         add_filter ( 'woocommerce_after_cart_table', 'qwebmaster_ai_woocommerce_display', 10, 2 );
      }

    }

    // Checkout Page
    if ( isset($options['wasp_enable_checkout']) && $options['wasp_enable_checkout'] == 1) {

      // Position
      if ( $options['wasp_location_checkout'] == 'top') {
         add_filter ( 'woocommerce_before_checkout_form', 'qwebmaster_ai_woocommerce_display', 10, 2 );
      }
      if ( $options['wasp_location_checkout'] == 'bottom') {
         add_filter ( 'woocommerce_after_checkout_form', 'qwebmaster_ai_woocommerce_display', 10, 2 );
      }

    }

    // Single Product Page
    if ( isset($options['wasp_enable_single_product']) && $options['wasp_enable_single_product'] == 1) {

      // Position
      if ( $options['wasp_location_single_product'] == 'top') {
         add_filter ( 'woocommerce_before_single_product', 'qwebmaster_ai_woocommerce_display', 10, 2 );
      }
      if ( $options['wasp_location_single_product'] == 'bottom') {
         add_filter ( 'woocommerce_after_single_product', 'qwebmaster_ai_woocommerce_display', 10, 2 );
      }

    }


}



/**
 *
 *
 * Woocommerce AI Suggested Products Display
 *
 * @since v1.0 Initial Public Relese.
 */
function qwebmaster_ai_woocommerce_display() {
  global $woocommerce;
  $items = $woocommerce->cart->get_cart();
      $cart_product_ids =[];
      $predictions =[];
      $orders = qwebmaster_ai_get_orders(500);
      // Loop each cart item
      foreach($items as $item => $values) {
         $prediction = qwebmaster_ai_apriori($orders,$values['data']->get_id());
         // Build Prediction array
         $predictions[] =  $prediction;
         // Store an array of all cart products
         $cart_product_ids[] = $values['data']->get_id();
      }
$predictions = qwebmaster_ai_filter_array(array_unique(qwebmaster_ai_convert_array($predictions), SORT_REGULAR),$cart_product_ids);
//qwebmaster_print_array($predictions);
echo qwebmaster_ai_product_tempalte($predictions);
}


/**
 *
 *
 * Register and load the WASP widget
 *
 * @since v1.0 Initial Public Relese.
 */
function wpb_load_widget() {
    register_widget( 'wasp_widget' );
}
add_action( 'widgets_init', 'wpb_load_widget' );

// Creating the widget
class wasp_widget extends WP_Widget {

function __construct() {
parent::__construct(

// Base ID of your widget
'wasp_widget',

// Widget name will appear in UI
__('Woocommerce AI Suggested Products', 'wasp_widget_domain'),

// Widget description
array( 'description' => __( 'Woocommerce AI Suggested Products', 'wasp_widget_domain' ), )
);
}

// Creating widget front-end
public function widget( $args, $instance ) {
$title = apply_filters( 'widget_title', $instance['title'] );

// before and after widget arguments are defined by themes
echo $args['before_widget'];
if ( ! empty( $title ) )
echo $args['before_title'] . $title . $args['after_title'];
// Load HTML
qwebmaster_ai_woocommerce_display();
}

// Widget Backend
public function form( $instance ) {
if ( isset( $instance[ 'title' ] ) ) {
$title = $instance[ 'title' ];
}
else {
$title = __( 'Suggested Products', 'wasp_widget_domain' );
}
// Widget admin form
?>
<p>
<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label>
<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
</p>
<?php
}

// Updating widget replacing old instances with new
public function update( $new_instance, $old_instance ) {
$instance = array();
$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
return $instance;
}
} // Class wasp_widget ends here




/**
 * HOOK wp_footer
 *
 * Wordpress footer hook for CSS and JS
 *
 * @since v1 Initial Public Relese.
 */
add_action('wp_footer', 'qwebmaster_ai_foooter');
function qwebmaster_ai_foooter(){ ?>
<?php
};
